unit SharedLibrary;

interface

uses
	Types, CodeFragments, TextUtils, Memory, BigStrings, Speech;
	
const
	kFunctionName = '99_bottles_1.0';

function __initialize(ibp: CFragInitBlockPtr): OSErr;
procedure __terminate;
function GetName(name: StringPtr): OSErr;
function Analyze(param: BigStringPtr): OSErr;

implementation

{

	__initialize

	This function is called when the Shared Library is 
	connected to by the Application.

}

function __initialize(ibp: CFragInitBlockPtr): OSErr;
var
	err: OSErr;
begin
	err := noErr;

	__initialize := err;
end;

{

	__terminate

	This function is called when the connection to the 
	Shared Library is closed by the Application.

}

procedure __terminate;
begin
	
end;

function GetName(name: StringPtr): OSErr;
var
	s: String;
begin
	s := kFunctionName;
	BlockMoveData(@s, name, Length(s) + 1);
	GetName := noErr;
end; { GetName }

function TrouveNombre(b: BigStringPtr; var debut: Integer): Integer;
var
	fin, l: Integer;
	s: Str255;
	dum: LongInt;
begin
	{ Sauter par dessus les blancs }
	while (b^.chr[debut] = ' ') do
		debut := debut + 1;
	fin := debut;
	while (fin < b^.length) and (b^.chr[fin] in ['0'..'9']) do
		fin := fin + 1;
	l := fin - debut; { pas de +1 car chr(fin) <> nombre }
	if (fin = b^.length) then { sauf dans ce cas-ci! }
		l := l + 1;
	if l > 255 then
		l := 255;
	BlockMoveData(@b^.chr[debut], @s[1], l);
{$push}
{$r-}
	s[0] := Chr(l);
{$pop}
	StringToNum(s, dum);
	TrouveNombre := dum;
	debut := fin;
end; { TrouveNombre }


{
	Analyze

}

function Analyze(param: BigStringPtr): OSErr;
var
	s, s1: Str255;
	err: Integer;
	nBottles, i, count: LongInt;
	when, now: UInt32;
	dtr: DateTimeRec;
	theEvent: EventRecord;
begin
	if (param <> nil) then begin
		BigStringToStr(param, s);
		GetTime(dtr);
		DateToSeconds(dtr,now);
		ReadString(s, nBottles, count, dtr.hour, dtr.minute, dtr.second);
		DateToSeconds(dtr,when);
		
		while (now < when) do begin
			GetTime(dtr);
			DateToSeconds(dtr,now);
			if WaitNextEvent(nullEvent,theEvent,2,nil)  then ; { give time while waiting }
		end;
		
		if (nBottles > 0) and (nBottles < 100) then begin
			for i := 1 to count do begin
				NumToString(nBottles, s);
				NumToString(nBottles - 1, s1);
				s := Concat(s, ' bottles of beer on the wall, ', s, ' bottles of beer... Take one down, pass it around, ', s1, ' bottles of beer on the wall.' );
			
				err := SpeakString(s);
				while (SpeechBusy <> 0) do ;
				nBottles := nBottles - 1;
			end;
		end;
		
		Analyze := noErr;
	end else 
		Analyze := -1;
end;

end.