unit RDeclarations;

interface

{$IFC undefined THINK_PASCAL}
{$SETC THINK_PASCAL := FALSE}
{$ENDC}
{$IFC undefined MPW_PASCAL}
{$SETC MPW_PASCAL := FALSE}
{$ENDC}
{$IFC undefined MACTARGET}
{$SETC MACTARGET := TRUE}
{$ENDC}
{$IFC undefined WINTARGET}
{$SETC WINTARGET := FALSE}
{$ENDC}
{$IFC undefined DLLTARGET}
{$SETC DLLTARGET := FALSE}
{$ENDC}

{$IFC MACTARGET}
	uses
		Types, Windows, Files, QuickDraw, Lists;
{$ENDC}

	const

{ Changing these values to smaller values helps while debugging }
{    MAX_LENGTH = 1000;}
{    MAX_LENGTH = 32000;}
{		MAX_LENGTH = 64000;}
		MAX_LENGTH = 178956970;
{    MAX_LENGTH = MAXLONGINT;}

{ Generic error code }
		ERR_RESULT = -999;

		global_epsilon = 1E-7; { default value for epsilon, to distinguish between two real numbers }
		Pi2 = 6.283185308; { 2 x pi }
		SMALL_STR_LEN = 10;

		MaxReel = 10E300; { Maximum real number }
		MinReel = -10E300; { Minimum real number }
		Epsilon = 10E-7; { Another epsilon for A. Vaudor's stuff }

{ Languages }
		kLangFrancais = 0;
		kLangEnglish = 1;
		kLangEspanol = 2;

	type
{ These two types are already declared in MPW and Think Pascal }
{$IFC NOT MPW_PASCAL AND NOT THINK_PASCAL}
		IntegerPtr = ^Integer;
		LongIntPtr = ^LongInt;
{$ENDC}
		IntegerH = ^IntegerPtr;
		LongIntH = ^LongIntPtr;


{ Je dfinis ces types une fois pour toutes afin d'viter les problmes multi-plateformes }
{ I define these data types once to forego cross-platform problems }
		TReal = double;
		TInteger = LongInt;
		Str10 = string[SMALL_STR_LEN];
		TString = Str10;
		TPermutationMethod = (permNone, permVector, permMatrix, permDouble, permTriple);
		TMatrixType = (matRect, matSimil);
{$IFC WINTARGET}
		StringPtr = ^
		string[255];
{$ENDC}

		TRealPtr = ^TReal;
		TRealH = ^TRealPtr;
		TIntegerPtr = ^TInteger;
		TIntegerH = ^TIntegerPtr;

{ Dfinition universelle de matrices }
{ Universal definition of vectors and matrices }
		TStrVector = array[1..MAX_LENGTH] of TString;
		TStrVectorPtr = ^TStrVector;
{    TStrVectorH = ^TStrVectorPtr;}
		TBoolVector = array[1..MAX_LENGTH] of Boolean;
		TBoolVectorPtr = ^TBoolVector;
{    TBoolVectorH = ^TBoolVectorPtr;}
		TIntegerVector = array[1..MAX_LENGTH] of TInteger;
		TIntegerVectorPtr = ^TIntegerVector;
{    TIntegerVectorH = ^TIntegerVectorPtr;}
		TRealVector = array[1..MAX_LENGTH] of TReal;
		TRealVectorPtr = ^TRealVector;
{    TRealVectorH = ^TRealVectorPtr;}

{ Les matrices sont ranges par colonne }
{The matrices are stored column-wise }
		TColumnHeader = record
				n: TInteger;
				data: TRealVectorPtr;
			end;

		TMatrixColumn = array[1..MAX_LENGTH] of TColumnHeader;
		TMatrixColumnPtr = ^TMatrixColumn;
{    TMatrixColumnH = ^TMatrixColumnPtr;}

		TMatrix = record
				n, p, nObjects, root, nGroups: TInteger; { Paramtres de la matrice / Matrix parameters }
				refCon: LongInt; { Utilisation dfinie par le programmeur / Programmer-defined }
				col: TMatrixColumnPtr; { Accs aux donnes / Matrix data access }
				colName, rowName: TStrVectorPtr; { Noms des colonnes / Column names }
				indirection, { Vecteur d'indirection pour permutations / Indirection vector for permutations }
				group: TIntegerVectorPtr; { Pour grouper des objets (mat. simil ou rect.) / To group objects (rows) }
				includedRows, includedCols: TBoolVectorPtr; { pour inclure/exclure des lignes/colonnes / To include/exclude rows and columns }
				permMeth: TPermutationMethod; { Mthode de permutation si ncessaire / Permutation method, if necessary }
				matType: TMatrixType; { matrice rectangulaire ou de ressemblance? / Is this a rectangular of resemblance matrix? }
				s1, s2, s3: StringPtr; { Pour conserver de l'information quelconque / To save some textual information }
			end;
		TMatrixPtr = ^TMatrix;
{    TMatrixH = ^TMatrixPtr;}

{$IFC MACTARGET}

{ Window types in the R Package }
		RWindowType = (wNone, wSimil, wMatrix, wText, wPicture, wPiste);

		WindowInfo = record { What to put in a file window's RefCon }
				owner: OSType; { creator tag }
				wType: RWindowType;
				pictType: Integer;
				dessin: PicHandle;
				fss: FSSpecPtr; { File info }
				windowMatrix: TMatrixPtr; { simil, matrix, dessin, piste }
				list: Handle; { simil, matrix }
				textH: Handle; { text }
				pisteData: Handle; { piste information }
				language: Integer;
				active, incomplete, busy, dirty: Boolean;
			end; { WindowInfo }
		WindowInfoPtr = ^WindowInfo;

{ Window list definitions }
		TWindowListPtr = ^TWindowList;
		TWindowListH = ^TWindowListPtr;
		TWindowList = record { Utilis pour le menu "Windows" / Used for the "Windows" menu, and to walk the window list }
				window: WindowPtr;
				next: TWindowListH;
			end;

{ Declarations for MyVariableList.p }
		CellArray = array[1..MaxInt] of Cell;
		CellArrayPtr = ^CellArray;
		TVariableList = (varX, varY, varZ1, varZ2, varZ3, varZ4, varZ5, varZ6, varLast);
		TVarStr = array[varX..varZ6] of Str10;
		TVarPos = array[varX..varZ6] of CellArrayPtr;
{ This is placed in the list's userHandle so the list info and list item }
{ can be accessed by the support functions }
		TVariableListDataH = ^TVariableListDataPtr;
		TVariableListDataPtr = ^TVariableListData;
		TVariableListData = record
				itemNumber: Integer; { which item in the dialog is our list? }
{ position of the x, y, z selection: cell.h = window number, cell.v = variable in window cell.h }
				varPos: TVarPos;
{ strings associated with said variable selections, to prefix the name when drawing }
				varStr: TVarStr;
				showMatrix, showSim, showDist: Boolean;
			end; { record }

		TVariableListElementH = ^TVariableListElementPtr;
		TVariableListElementPtr = ^TVariableListElement;
		TVariableListElement = record
				wPtr: WindowPtr;
				name: Str255;
				position: Cell; { cell.h = window number, cell.v = variable in window cell as above }
				case isWindow : Boolean of
					true: (
							wType: RWindowType;
							mat: TMatrixPtr;
							isOpened: Boolean
					); { if isWindow }
					false: (
							parent: Cell; { a real cell in the list, now... }
					) { if not isWindow }
			end; { record }

{$ENDC}

{ Data matrix access }

{ This file should contain only definitions, not code, but I felt it was }
{ necessary to include these two procedures here so that Extensions could }
{ have access to them without using all the overhead of a callback function. }
{ You could replace calls to these procedures with an inline expression (in }
{ fact this is what the macro does under CW & FAST_MATRIX_ACCESS), but IMHO }
{ the code would lose readability if you did that. }
{ These are the reasons that I am breaking with tradition and including *some* }
{ code in this definitions file. }

{ Mod. PhC 16/03/01 }
{ In some cases (notably, C extensions), if GetElement/SetElement are replaced }
{ by macros, the linker will (obviously) not find the functions. Therefore, I }
{ also define the GetElementFunc and SetElementProc to fill in these blanks, }
{ and satisfy the linker. In all internal code to R, one should still use Get/ }
{ SetElement, though. }

{ This directive replaces GetElement/SetElement by macros instead of }
{ procedures, which makes the access much faster albeit less safe (no }
{ assertions, for instance). Deactivated under Think Pascal because TP }
{ does not support $definec. }
{ Set to TRUE for fast, unchecked access and FALSE for slower, safer access. }
{$setc FAST_MATRIX_ACCESS := TRUE}
{$ifc THINK_PASCAL}
{$setc FAST_MATRIX_ACCESS := FALSE}
{$endc}

{$ifc FAST_MATRIX_ACCESS}
{ inline macros }
{$definec GetElement(m, i, j) m^.col^[j].data^[i] }
{$definec SetElement(m, i, j, value) m^.col^[j].data^[i]:=value }
{ procedures and functions }
	function GetElementFunc (m: TMatrixPtr; i, j: TInteger): TReal;
	procedure SetElementProc (var m: TMatrixPtr; i, j: TInteger; value: TReal);
{$elsec}
{ procedures and functions }
	function GetElement (m: TMatrixPtr; i, j: TInteger): TReal;
	procedure SetElement (var m: TMatrixPtr; i, j: TInteger; value: TReal);
	function GetElementFunc (m: TMatrixPtr; i, j: TInteger): TReal;
	procedure SetElementProc (var m: TMatrixPtr; i, j: TInteger; value: TReal);
{$endc}


implementation

{$ifc not FAST_MATRIX_ACCESS}
	function GetElementFunc;
	begin
		GetElementFunc := GetElement(m, i, j);
	end;

	function GetElement;
{$elsec}
		function GetElementFunc;
{$endc}
			var
				result: TReal;
		begin
			result := ERR_RESULT;
			if m <> nil then
				if (i > 0) and (i <= m^.n) and (j > 0) and (j <= m^.p) then
					if m^.col <> nil then
						if m^.col^[j].data <> nil then
							result := m^.col^[j].data^[i];
{$ifc not FAST_MATRIX_ACCESS}
			GetElement := result;
{$elsec}
			GetElementFunc := result;
{$endc}
		end; { function }

{$ifc not FAST_MATRIX_ACCESS}
		procedure SetElementProc;
		begin
			SetElement(m, i, j, value);
		end;

		procedure SetElement;
{$elsec}
			procedure SetElementProc;
{$endc}
			begin
				if m <> nil then
					if (i > 0) and (i <= m^.n) and (j > 0) and (j <= m^.p) then
						if m^.col <> nil then
							if m^.col^[j].data <> nil then
								m^.col^[j].data^[i] := value;
			end; { SetElement }

			end.