/*
 * CScript 0.1
 * 1998 Cache Computing
 *
 * Thanks to Ed Wynne for performance enhancements.
 *
 * Comments / Suggestions welcome at support@cache-computing.com
 *
*/


#include <string.h>
#include <AppleEvents.h>
#include <OSA.h>
#include <AppleScript.h>
#include <AERegistry.h>

#include "CScript.h"

#define NoComponentFound -1

ComponentInstance	gScriptingComponent = NULL;
OSASendUPP			gMySendProc = NULL;
OSASendUPP 			oldSendProc;
long				refCon;


/*
 * MySendProc
 *
 * Stolen from a code snippet written by...i dunno :-)
 *
*/
pascal OSErr MySendProc(const AppleEvent* theAppleEvent, AppleEvent* reply, AESendMode sendMode,
							AESendPriority sendPriority, long timeOutInTicks, AEIdleUPP idleProc,
							AEFilterUPP filterProc, long refCon);
pascal OSErr MySendProc(const AppleEvent* theAppleEvent, AppleEvent* reply, AESendMode sendMode,
							AESendPriority sendPriority, long timeOutInTicks, AEIdleUPP idleProc,
							AEFilterUPP filterProc, long refCon)
{ 
#pragma unused(refCon)

	DescType     typeCode;
	Size         descSize;
	OSErr        iErr;
	OSErr        ignoreErr;
	OSType       whatEvent;
	AppleEvent   myCopyAEvt;
		

	iErr = AEDuplicateDesc(theAppleEvent, &myCopyAEvt);
	
	iErr = AEGetAttributePtr(&myCopyAEvt, keyEventIDAttr, typeType, &typeCode, (Ptr) &whatEvent, sizeof(whatEvent), &descSize);
															
	ignoreErr = AEDisposeDesc(&myCopyAEvt);
		

	if (iErr != noErr) whatEvent = 0x3F3F3F3F;

	if ((sendMode & kAEDontRecord) && ((whatEvent!=kAEGetData) && (whatEvent!='gdte')))
		sendMode = sendMode - kAEDontRecord;
			
		
		return(AESend(theAppleEvent, reply, sendMode, sendPriority, timeOutInTicks, idleProc, filterProc));							
}
	
	
OSErr InitCScript(void)
{
	OSErr	iErr = noErr;
				
			
	gScriptingComponent = OpenDefaultComponent(kOSAComponentType,typeAppleScript);
	if (gScriptingComponent == NULL)
		return NoComponentFound;
	
	iErr = OSAGetSendProc(gScriptingComponent,&oldSendProc,&refCon);
	if (iErr == noErr)
		iErr = OSASetSendProc(gScriptingComponent,(gMySendProc = NewOSASendProc(MySendProc)),0);
	
	if (iErr != noErr)
		CloseComponent(gScriptingComponent);
	
	return(iErr);
 }


OSErr DisposeCScript(void)
{
	OSErr                iErr = noErr;
	
	
	if (gScriptingComponent != NULL)
	{
		iErr = CloseComponent(gScriptingComponent);
		gScriptingComponent = NULL;
	}
	
	if (gMySendProc != NULL)
	{
		DisposeRoutineDescriptor(gMySendProc);
		gMySendProc = NULL;
	}
	
	return iErr;
}


OSErr CScript(char *text)
{
	OSErr             iErr;
	OSErr             ignoreErr;
	AEDesc            TextDesc;
	OSAID             ScriptID;
				
	
	TextDesc.dataHandle = nil;
	
	if (gScriptingComponent == NULL)
	{
		iErr = InitCScript();
		if (iErr != noErr)
			return iErr;
	}
	
	iErr = AECreateDesc(typeChar, text, strlen(text), &TextDesc);
												 
		
	if (iErr==noErr)
	{

		ScriptID = 0;
		
		iErr = OSACompileExecute(gScriptingComponent,&TextDesc,0,0,&ScriptID);
		if (iErr==noErr)
			ignoreErr = OSADispose(gScriptingComponent,  ScriptID);
	}

	if (TextDesc.dataHandle)
		ignoreErr = AEDisposeDesc(&TextDesc);

	return(iErr);		
}
