/*
     File:       WirelessAPI.h
 
     Contains:   Wireless API
 
     Version:    MacHack 2001
  
*/

#ifndef __WIRELESSAPI__
#define __WIRELESSAPI__

#ifndef __MACTYPES__
#include <MacTypes.h>
#endif

//#define ASSERT(x) if (x == false) Debugger()

#ifdef __cplusplus
extern "C" {
#endif

//	Opaque reference to a dev
typedef UInt32	WirelessDeviceRef;

struct WirelessNodeInfo
{
    UInt16							fUndefined1;
    UInt16							fNoiseLevel;
    UInt16							fSignalLevel;
    UInt16							fMACAddress[3];
    UInt16							fUndefined2;
    UInt16							fUndefined3;
    char							fName[34];
};
typedef struct WirelessNodeInfo		WirelessNodeInfo;
typedef WirelessNodeInfo *			WirelessNodeInfoPtr;

OSStatus		WirelessConnect(WirelessDeviceRef* outRef, UInt32 inMagic);

OSStatus		WirelessScan(WirelessDeviceRef inRef, WirelessNodeInfoPtr ioResultData, SInt32* ioResultCount);

OSStatus		WirelessScanMerge(WirelessDeviceRef inRef, WirelessNodeInfoPtr ioResultData, SInt32* ioResultCount, SInt32 inIterationCount, UInt32 inDelayValue);

OSStatus		WirelessDisconnect(WirelessDeviceRef inRef);
	
#ifdef __cplusplus
}
#endif

#endif /* __WIRELESSAPI__ */

