#include <LowMem.h>
#include <OSUtils.h>
#include <MacTypes.h>
#include <Events.h>
#include <Dialogs.h>
#include <Resources.h>

#include "MoreCFMPatches.h"

typedef Boolean (*DialogSelectPtr) (
	const EventRecord *	theEvent,
	DialogPtr *			theDialog,
	DialogItemIndex *		itemHit);

Boolean MyDialogSelect (
	const EventRecord *	theEvent,
	DialogPtr *			theDialog,
	DialogItemIndex *		itemHit);

void main (void)
{
//	DebugStr ("\pDFA");
	
	THz saveZone = GetZone ();
	SetZone (SystemZone ());

	OSStatus err = MorePatchTVector ((TVector*) DialogSelect, (TVector*) MyDialogSelect, 'Miro', nil);

	Handle	myResource = Get1Resource ('INIT', 0);
	DetachResource (myResource);
	
	HLock (myResource);

	SetZone (saveZone);
}

Boolean MyDialogSelect (
	const EventRecord *	theEvent,
	DialogPtr *			theDialog,
	DialogItemIndex *		itemHit)
{
	// Only the first time we are called in the DFA dialog
	static Boolean	sAlreadyRun = false;

	if (!sAlreadyRun) {
		Boolean		rightDialog = false;
		
		if ((LMGetCurApName () [0] & 0x80) != 0) {
			// We are at INIT time
			GrafPtr	thePort;
			GetPort (&thePort);

			// The dialog looks right
			Rect	dialogSize = thePort -> portRect;
			if ((dialogSize.bottom - dialogSize.top == 245) && (dialogSize.right - dialogSize.left == 450)) {
				rightDialog = true;
			}
		}
		
		if (rightDialog) {
			sAlreadyRun = true;
			*itemHit = 1;
			return true;
		}
	}
			
	return ((DialogSelectPtr) gMoreCFMPatchesCallThrough) (theEvent, theDialog, itemHit);
}

