#!/usr/bin/perl

#
# requires dbd-csv
#
# unix:  perl -MCPAN -e shell
# cpan>install dbd::csv
#
# win32: ppm> install dbd-csv
#
# this script creates the database file that the other
# scripts later use
#
# be sure to set perl to where it is in your path
# see the O'Reilley CGI Programming book for examples
#

#
# directory where database files are to be stored
#

$dbdir = ".";

#
# comments about data format
#

use DBI;
#use CGI::Carp qw(FatalsToBrowser);

my $dbh = DBI->connect("DBI:CSV:f_dir=$dbdir")
        or die "Can't connect: " . $DBI::errstr;

my $sql = "
create table data
(  user                 char (256) not null,
   email                char (256) not null,
   read_msg_avg_day     char (256) not null,
   sent_msg_avg_day     char (256) not null,
   usage_avg_day        char (256) not null
)";

my $sth = $dbh->prepare($sql)
        or die "Can not prepare: " . $dbh->errstr();

$sth->execute()
        or die "Can not execute: " . $sth->errstr();

$sth->finish();

$dbh->disconnect;
