// pane.h

// pane base class, for any UI item which does not contain other items
#pragma once
#define PILOT_PRECOMPILED_HEADERS_OFF
#include <Pilot.h>

class view;

class pane {
public:
					pane(RectangleType* in_bounds, view* in_superview);
					pane(view* in_superview);
					pane(); // default constructor
	virtual		~pane();
	
	virtual void		draw(); 
	virtual Boolean	click(int x, int y); 
	virtual Boolean	still_down(int x, int y); 
	virtual Boolean	pen_up(int x, int y); 
	virtual void		idle();
	
	view*		get_superview();
	int			get_width() {return m_bounds.extent.x;};
	int			get_height() {return m_bounds.extent.y;};
	
protected:
	view*				m_superview;
	pane*				m_next_pane;
	RectangleType		m_bounds;
	Boolean				m_visible;
	
	virtual void		draw_self();
	virtual Boolean	click_self(int x, int y);
	virtual Boolean	still_down_self(int x, int y);
	virtual Boolean	pen_up_self(int x, int y);
	virtual void		idle_self();

private:
	void					add_to_master_list();
	void					remove_from_master_list();
};