// window.cp

#include "window.h"

//
// constructor
//
window::window (RectangleType* in_bounds, view* in_superview, Boolean in_visible)
	:view (in_bounds, in_superview)
{
	m_visible = in_visible;
}

//
// destructor
//
window::~window ()
{
}

//
// draw_self()
//
void
window::draw_self()
{
	RectangleType		r;
	PointType			s, e;
	
	get_content_rect(&r);
	
	// check if rectangle is big enough
	if ((r.extent.x<=2) || (r.extent.y<=2))
		return;
	
	// draw bottom shadow
	s.x = r.topLeft.x + 1;
	s.y = r.topLeft.y + r.extent.y + 1;
	e.x = r.topLeft.x + r.extent.x + 1;
	e.y = s.y;
	WinDrawLine(s.x, s.y, e.x, e.y);
	
	// draw right shadow
	s.x = e.x;
	s.y = r.topLeft.y + 2;
	WinDrawLine(s.x, s.y, e.x, e.y);
	
	// draw rectangle frame
	WinDrawRectangleFrame (simpleFrame, &r);
	
	// erase contents
	WinEraseRectangle(&r, 0);
	
	// draw contents
}

//
// get_content_rect()
//
void					
window::get_content_rect( RectangleType* r ) 
{	
	*r = m_bounds;
}

//
//
// click_self()
//
Boolean	
window::click_self(int x, int y) {
	
	return false;
}

//
// do_cmd_self
//
Boolean	
window::do_cmd_self (int in_eventID, void* io_data)
{
	return false;
}
