/*
This file and its intellectual contents are considered property of the creator and are to be treated as such with respect to use in other applications.  Any use of this software for any purpose whatsoever must have explicit permission from the author of the file.  This code is part of an ongoing development process for future possible products, and so is considered private property.
Do not use without permission.  Author: Scott C. Ziegler <Aslan@Narnia.net>
*/

package Arcana;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Color;

// SpellRegister
//
//		designed to hold the organizational aspect of a spell for
//		sorting and display.	
	
public class SpellRegister implements Sorter.Comparable, Serializable {
	
	String 		Name;
	String 		School;
	int 		Level;
	int 		Components;
	
	// *** need reference to related SpellRecord
	SpellRecord	SourceSpell;
	
	// Constructors
	
	public SpellRegister() {} 
	// to be followed shortly by a call to setRegister()
	
	public SpellRegister(SpellRecord spell) {
		Name = new String(spell.getName());
		School = new String(spell.getSchool());
		Level = spell.getLevel();
		Components = spell.getComponents();
		SourceSpell = spell;
		}
	
	// Selectors
	
	public String getName() {
		return Name;
		}
		
	public String getSchool() {
		return School;
		}
		
	public int getLevel() {
		return Level;
		}
		
	public int getComponents() {
		return Components;
		}
		
	public SpellRecord getSourceSpell() {
		return SourceSpell;
		}
		
	// Mutators
	
	public void setLevel(int lvl) {
		Level = lvl;
		}
		
	public void setName(String name) {
		Name = name;
		}
		
	public void setSchool(String school) {
		School = school;
		}
		
	public void setComponents(int comps) {	
		Components = comps;
		}
	
	public void setSourceSpell(SpellRecord spRec) {
		SourceSpell = spRec;
		}
	
	public void setRegister(SpellRecord spell) {
		Name = spell.getName();
		School = spell.getSchool();
		Level = spell.getLevel();
		Components = spell.getComponents();
		SourceSpell = spell;
		}
		
	// Interface - Sorter.Comparable
		
	public int compareTo(Object other) {
		return Name.compareTo(((SpellRegister)other).getName());
		}
		
	}