#!/usr/bin/perl -w
#
# Script name: headerDoc
# Synopsis: Master script to run headerDoc2HTML and gatherHeaderDoc.
#
# Author: Matt Morse (matt@apple.com)
# Last Updated: $Date: $
#
#####################################################################
use Cwd;
use Getopt::Std;
use File::Find;

print "\n\nheaderDoc.pl\n";

my %options = ();
my $scriptDir = cwd();
my $specifiedOutputDir;
my $bastardizationMode='';

&getopts("dvb:o:", \%options);
if ($options{o}) {
	$specifiedOutputDir = $options{o};
}
	
if ($options{b}) {
	$bastardizationMode = $options{b};
}

my $inputDir = $ARGV[0];

my @headerDocArgs = ("$scriptDir/headerDoc2HTML.pl", "-o", "$specifiedOutputDir", "$inputDir");
system(@headerDocArgs) == 0 or die "system @headerDocArgs failed: $?";

my @gatherDocArgs = ("$scriptDir/gatherHeaderDoc.pl", "$specifiedOutputDir");
system(@gatherDocArgs) == 0 or die "system @gatherDocArgs failed: $?";

if (length($bastardizationMode)) {
	my @pseudoDocArgs = ("$scriptDir/pseudoDoc.pl", "-b", "$bastardizationMode", "$specifiedOutputDir");
	system(@pseudoDocArgs) == 0 or die "system @gatherDocArgs failed: $?";
}
exit 0;